
{ Unit for TED font manipulation in 13h VGA mode }
{ Code by VanDamM / [WRC] / 1999                 }

{ TED FONT technology by Paradise '94            }

Unit D_Sharp;

interface
Uses V_Sharp;
Var
 F              : File;
 B              : Byte;
 Palette        : Array [0..255, 1..3] Of Byte;
 Chars          : Array [' '..']'] Of Pointer;
 CharsData      : Array [' '..']',1..3] Of Byte;


Procedure SetColor(Nr, R, G, B : Byte);

Procedure LoadTED(Name: String);
Procedure LoadPal(Name: String);

Procedure PutCharXY( WhereDraw : DBufferPtr; X, Y : Integer; Ch : Char);
Procedure WriteXY  ( WhereDraw : DBufferPtr; X, Y : Integer; S  : String);

Procedure DoneTED;

implementation

Procedure SetColor(Nr, R, G, B : Byte); Assembler;
Asm
 mov dx,3c8h
 mov al,nr
 out dx,al
 inc dx
 mov al,r
 out dx,al
 mov al,g
 out dx,al
 mov al,b
 out dx,al
End;

Procedure LoadPal(Name: String);
Begin
 Assign(F, Name+'.pal'); Reset(F, 1);
 Blockread(F, Palette, 768); Close(F);
 For B:=0 To 255 Do Setcolor(B, Palette[B,1], Palette[B,2], Palette[B,3]);
End;

Procedure PutCharXY( WhereDraw : DBufferPtr; X, Y : Integer; Ch : Char);
Var Xr, Yr, Ax, Ay : Byte;
Begin
 Xr:=CharsData[Ch, 1];
 Yr:=CharsData[Ch, 2];
 For Ay:=1 To Yr Do
  For Ax:=1 To Xr Do
   Begin
    B:=Mem[Seg(Chars[Ch]^):Ofs(Chars[Ch]^)+(Ay-1)*Xr+Ax-1];
    If B>0 Then PutPixel(WhereDraw, X+Ax-1, Y+Ay-1, 130);
   End;
End;

Procedure WriteXY( WhereDraw : DBufferPtr; X, Y : Integer; S : String);
Var ABSx, ABSy: Integer; Nr: Byte;
Begin
 ABSx:=X; ABSy:=Y;
 For Nr:=1 To Length(S) Do
  If S[Nr] In [' '..']'] Then
   Begin
    If S[Nr]=' ' Then Inc(ABSx, CharsData[S[Nr+1],1]+1)
    Else
     Begin
      PutCharXY(WhereDraw, ABSx, ABSy, S[Nr]);
      Inc(ABSx,CharsData[S[Nr],1]+1);
     End;
   End;
End;

Procedure LoadTED(Name: String);
Var Tx,Ty: Byte; Ch: Char;
Begin
 Assign(F, Name+'.ted'); Reset(F, 1);
 Seek(F, 20);
 While Not(Eof(F)) Do
  Begin
   Blockread(F, Ch, 1);
   Blockread(F, Tx, 1);
   Blockread(F, Ty, 1);
   GetMem(Chars[Ch], Tx*Ty);
   CharsData[Ch, 1]:=Tx;
   CharsData[Ch, 2]:=Ty;
   CharsData[Ch, 3]:=1;
   BlockRead(F, Chars[Ch]^, Tx*Ty);
  End;
 Close(F);
End;

Procedure DoneTED;
Var Ch: Char;
Begin
 For Ch:=' ' To ']' Do
 Begin
  If CharsData[Ch,3]=1 Then
  Begin
   FreeMem(Chars[Ch], CharsData[Ch, 1] * CharsData[Ch, 2]);
   CharsData[Ch,3]:=0;
  End;
 End;
End;

Begin
End.