{ Code by VanDamM / [WRC] }
{F+}
Unit mpalette;
Interface
Const

 Title = '** Magic Palettes v1.1, Writen and tested By VanDamM. 1997 **';

Type
 RGBColor = record
             R : byte;
             G : byte;
             B : byte;
            end;

 PaletteArray = Array [0..255] of RGBColor;

Var
 PaletteTmp   : PaletteArray;
 PaletteUsr   : PaletteArray;

Procedure SetPaletteM(Var P);

Procedure Set_Palette_Register(index: integer; color: RGBColor);

Procedure PaletteSlowOn;

Procedure PaletteSlowOff;

Procedure GetRealPalette; { 祬  祭 , BIOS  }

Procedure SetBorderColor(BColor : byte);

Procedure PaletteRoll_R(CBegin, CEnd: byte);

Procedure PaletteRoll_L(CBegin, CEnd: byte);

Procedure PaletteHalfTone(CBegin, CEnd: word);

Procedure ZeroPalette;

Procedure FadeFromPaletteToPalette (Var Palette1 : PaletteArray;
                                    Var Palette2 : PaletteArray);

Procedure FadePalette(R1, G1, B1, R2, G2, B2, CStart, CEnd : Byte);


Implementation

Procedure FadePalette(R1, G1, B1, R2, G2, B2, CStart, CEnd : Byte);
Var Rstep,Gstep,Bstep,Rval,Gval,Bval:Longint;
    I:Integer;

Procedure SetColor(Nr, R, G, B : Byte); Assembler;
Asm
 mov dx,3c8h
 mov al,nr
 out dx,al
 inc dx
 mov al,r
 out dx,al
 mov al,g
 out dx,al
 mov al,b
 out dx,al
End;

Begin
  Rval:=Longint(R1) Shl 8;
  Gval:=Longint(G1) Shl 8;
  Bval:=Longint(B1) Shl 8;
  Rstep:=Longint(R2-R1+1) Shl 8 Div (Cend-Cstart+1);
  Gstep:=Longint(G2-G1+1) Shl 8 Div (Cend-Cstart+1);
  Bstep:=Longint(B2-B1+1) Shl 8 Div (Cend-Cstart+1);
  For I:=Cstart To Cend Do
   Begin
     SetColor(I,Rval Div 256,Gval Div 256,Bval Div 256);
     Rval:=Rval+Rstep;
     Gval:=Gval+Gstep;
     Bval:=Bval+Bstep;
   End;
End;

Procedure ZeroPalette;
Var i : byte;
    Pal : array[0..255] of RGBColor;
 Begin
  For i:=0 to 255 do
   Begin
    Pal[i].R:=0;
    Pal[i].G:=0;
    Pal[i].B:=0;
   End;
  SetPaletteM(Pal);
 End;

Procedure PaletteHalfTone(CBegin, CEnd: word); Assembler;
  Asm
   mov ah, 10h
   mov al, 1bh
   mov bx, 0
   mov cx, 155
   int 10h
  End;

Procedure PaletteRoll_L(CBegin, CEnd: byte);
Var
  C : RGBColor;
  i : byte;
 Begin
  C:=PaletteUsr[CBegin];
   For i:=CBegin to CEnd-1 do
    begin
     PaletteUsr[i]:=PaletteUsr[i+1];
    end;
  PaletteUsr[CEnd]:=C;
 End;

Procedure PaletteRoll_R(CBegin, CEnd: byte);
Var
  C : RGBColor;
  i : byte;
 Begin
  C:=PaletteUsr[CEnd];
   For i:=CEnd downto CBegin+1 do
    begin
     PaletteUsr[i]:=PaletteUsr[i-1];
    end;
  PaletteUsr[CBegin]:=C;
 End;

Procedure SetBorderColor(BColor : byte); Assembler;
 Asm
  mov ah, 10h
  mov al, 01h
  mov bh, BColor
  int 10h
 End;

Procedure GetRealPalette;
Var i : word;
    C : RGBColor;
 Begin
  For i:=0 to 255 do
   Begin
    asm
     mov ah, 10h
     mov al, 15h
     mov bx, i
     int 10h
     mov C.R, dh
     mov C.G, ch
     mov C.B, cl
    end;
     PaletteUsr[i]:=C;
   End;
 End;

Procedure PaletteSlowOff;
Const
  ZeroTime : LongInt = 0;
Var
  i, j     : Byte;
  Time     : LongInt absolute $0040:$006C;
Begin
  For j:=64 downto 1 do begin
    For i:=0 to 255 do
      With PaletteTmp[i] do begin
        R := PaletteUsr[i].R * j div 64;
        G := PaletteUsr[i].G * j div 64;
        B := PaletteUsr[i].B * j div 64;
      end;
    Repeat Until Time - ZeroTime > 0;
    ZeroTime := Time;
    SetPaletteM(PaletteTmp);
  end;
End;

Procedure PaletteSlowOn;
Const
  ZeroTime : LongInt = 0;
Var
  i, j     : Byte;
  Time     : LongInt absolute $0040:$006C;

Begin
  For j:=1 to 64 do begin
    For i:=0 to 255 do
      With PaletteTmp[i] do begin
        R := PaletteUsr[i].R * j div 64;
        G := PaletteUsr[i].G * j div 64;
        B := PaletteUsr[i].B * j div 64;
      end;
    Repeat Until Time - ZeroTime > 0;
    ZeroTime := Time;
    SetPaletteM(PaletteTmp);
  end;
End;

Procedure Set_Palette_Register(index: integer; color: RGBColor);
 Begin
  port[$3C6]:= $FF;
  port[$3C8]:= index;
  port[$3C9]:= color.R;
  port[$3C9]:= color.G;
  port[$3C9]:= color.B;
 End;

Procedure SetPaletteM(Var P); assembler;
 Asm
   mov   dx, 3C8h
   mov   al, 0
   out   dx, al
   push  ds
   lds   si, P
   mov   bx, 2
 @@Nxt:
   cli
   mov   dx, 3DAh
 @@Wait2:
   in    al, dx
   test  al, 08h
   jz    @@Wait2
   mov   cx, 128*3
   mov   dx, 3C9h
 @@PalLoop:
   lodsb
   out   dx, al
   loop  @@PalLoop
   dec   bx
   cmp   bx, 0
   jne   @@Nxt
   sti
   pop   ds
 End;

Procedure FadeFromPaletteToPalette (Var Palette1 : PaletteArray;
                                    Var Palette2 : PaletteArray);
Var WorkPalette : PaletteArray;
    Counter     : Integer;
    CrossFade   : Integer;
Begin
     For CrossFade := 0 to 32 do
     Begin
       For Counter := 0 to 255 do
       Begin
         WorkPalette[Counter].R :=
             ((Palette1[Counter].R * (32 - CrossFade)) +
              (Palette2[Counter].R * CrossFade)) DIV 32;
         WorkPalette[Counter].G :=
             ((Palette1[Counter].G * (32 - CrossFade)) +
              (Palette2[Counter].G * CrossFade)) DIV 32;
         WorkPalette[Counter].B :=
             ((Palette1[Counter].B * (32 - CrossFade)) +
              (Palette2[Counter].B * CrossFade)) DIV 32;
       End;
       SetPaletteM(WorkPalette);
     End;
End;

End.